diff -uNrd ircd-hybrid-6.0/src/s_conf.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/s_conf.c
--- ircd-hybrid-6.0/src/s_conf.c	Fri Dec  1 01:28:50 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/s_conf.c	Sat Nov 17 12:34:56 2001
@@ -52,6 +52,11 @@
 #include <fcntl.h>
 #include <assert.h>
 
+#ifdef SERVICES
+#ifndef SPOOF_FREEFORM
+#define SPOOF_FREEFORM
+#endif
+#endif /* SERVICES */
 
 extern ConfigFileEntryType ConfigFileEntry; /* defined in ircd.c */
 
@@ -134,6 +139,17 @@
 /* conf xline link list root */
 struct ConfItem        *x_conf = ((struct ConfItem *)NULL);
 
+#ifdef DCCFILECHECK
+/* conf rline link list root */
+struct ConfItem        *r_conf = ((struct ConfItem *)NULL);
+static void clear_r_lines(void);
+#endif
+
+#ifdef OPERSPOOF
+/* conf vline link list root */
+struct ConfItem        *v_conf = ((struct ConfItem *)NULL);
+static void clear_v_lines(void);
+#endif
 
 static void makeQlineEntry(aQlineItem *, struct ConfItem *, char *);
 
@@ -262,6 +278,9 @@
   { CONF_OPERATOR,         RPL_STATSOLINE, 'O'},
   { CONF_HUB,              RPL_STATSHLINE, 'H'},
   { CONF_LOCOP,            RPL_STATSOLINE, 'o'},
+#ifdef OPERSPOOF
+  { CONF_VLINE,            RPL_STATSVLINE, 'V'},
+#endif
   { 0, 0, '\0' }
 };
 
@@ -373,6 +392,14 @@
     this_conf = x_conf;
   else if (flags & CONF_ULINE)
     this_conf = u_conf;
+#ifdef DCCFILECHECK
+  else if (flags & CONF_RLINE)
+    this_conf = r_conf;
+#endif
+#ifdef OPERSPOOF
+  else if (flags & CONF_VLINE)
+    this_conf = v_conf;
+#endif
   else return;
 
   for (aconf = this_conf; aconf; aconf = aconf->next)
@@ -380,6 +407,15 @@
       {
         get_printable_conf(aconf, &name, &host, &pass, &user, &port);
 
+#ifdef OPERSPOOF
+	if (flags & CONF_VLINE) {
+            sendto_one(sptr, form_str(numeric),
+                   me.name,
+                   sptr->name,
+                   host,
+                   user);
+	} else
+#endif
         sendto_one(sptr, form_str(numeric),
                    me.name,
                    sptr->name,
@@ -1367,6 +1403,14 @@
     this_conf = x_conf;
   else if(mask & CONF_ULINE)
     this_conf = u_conf;
+#ifdef DCCFILECHECK
+  else if(mask & CONF_RLINE)
+    this_conf = r_conf;
+#endif
+#ifdef OPERSPOOF
+  else if(mask & CONF_VLINE)
+    this_conf = v_conf;
+#endif
   else
     return((struct ConfItem *)NULL);
 
@@ -2028,7 +2072,12 @@
         case 'p':
           aconf->status = CONF_LISTEN_PORT;
           break;
-
+#ifdef DCCFILECHECK
+        case 'R': /* rejected filetypes */
+        case 'r':
+          aconf->status = CONF_RLINE;
+          break;
+#endif
         case 'Q': /* reserved nicks */
         case 'q': 
           aconf->status = CONF_QUARANTINED_NICK;
@@ -2039,6 +2088,12 @@
           aconf->status = CONF_ULINE;
           break;
 
+#ifdef OPERSPOOF
+        case 'V':
+	  aconf->status = CONF_VLINE;
+	  break;
+#endif
+
         case 'X': /* rejected gecos */
         case 'x': 
           aconf->status = CONF_XLINE;
@@ -2419,6 +2474,29 @@
           aconf->next = x_conf;
           x_conf = aconf;
         }
+#ifdef DCCFILECHECK
+       else if (aconf->status & CONF_RLINE)
+        {
+          dontadd = 1;
+          MyFree(aconf->user);
+          aconf->user = NULL;
+          aconf->name = aconf->host;
+          aconf->host = (char *)NULL;
+          aconf->next = r_conf;
+          r_conf = aconf;
+        }
+#endif
+#ifdef OPERSPOOF
+      else if (aconf->status & CONF_VLINE)
+       {
+         dontadd = 1;
+	 aconf->user = aconf->user;
+	 aconf->name = aconf->name;
+	 aconf->host = aconf->host;
+	 aconf->next = v_conf;
+	 v_conf = aconf;
+       }
+#endif
       else if (aconf->status & CONF_ULINE)
         {
           dontadd = 1;
@@ -3100,10 +3178,24 @@
         int_flags |= FLAGS_FULL;
       else if(*flags == 'y')
         int_flags |= FLAGS_SPY;
+      else if(*flags == 'l')
+        int_flags |= FLAGS_POWEROPER;
       else if(*flags == 'd')
         int_flags |= FLAGS_DEBUG;
       else if(*flags == 'n')
         int_flags |= FLAGS_NCHANGE;
+#ifdef SERVICES
+      else if(*flags == 'e')
+        int_flags |= FLAGS_SVCKILL;
+ #ifdef SILENCE_SUPPORT
+      else if(*flags == 'S')
+        int_flags |= FLAGS_SILENCE;
+ #endif
+#endif
+#ifdef DCCFILECHECK
+      else if(*flags == 'D')
+        int_flags |= FLAGS_NODCC;
+#endif
       flags++;
     }
 
@@ -3139,6 +3231,8 @@
     *flags_ptr++ = 'r';
   if(flags & FLAGS_SKILL)
     *flags_ptr++ = 'k';
+  if(flags & FLAGS_POWEROPER)
+    *flags_ptr++ = 'l';
   if(flags & FLAGS_FULL)
     *flags_ptr++ = 'f';
   if(flags & FLAGS_SPY)
@@ -3147,6 +3241,18 @@
     *flags_ptr++ = 'd';
   if(flags & FLAGS_NCHANGE)
     *flags_ptr++ = 'n';
+#ifdef SERVICES
+  if(flags & FLAGS_SVCKILL)
+    *flags_ptr++ = 'e';
+ #ifdef SILENCE_SUPPORT
+  if(flags & FLAGS_SILENCE)
+    *flags_ptr++ = 'S';
+ #endif
+#endif
+#ifdef DCCFILECHECK
+  if(flags & FLAGS_NODCC)
+    *flags_ptr++ = 'D';
+#endif
   *flags_ptr = '\0';
 
   return(flags_out);
@@ -3589,6 +3695,12 @@
     zap_Dlines();
     clear_special_conf(&x_conf);
     clear_special_conf(&u_conf);
+#ifdef DCCFILECHECK
+    clear_special_conf(&r_conf);
+#endif
+#ifdef OPERSPOOF
+    clear_special_conf(&v_conf);
+#endif
     clear_q_lines();
 }
 
@@ -3824,3 +3936,31 @@
   *end = '\0';
   return(field);
 }
+
+#ifdef OPERSPOOF
+int find_v_line(struct Client* sptr)
+{
+  struct ConfItem *aconf;
+  for (aconf = v_conf; aconf; aconf = aconf->next)
+    {
+      if (match(aconf->host,sptr->host) || match(aconf->host,sptr->sockhost) ||
+	    (aconf->host[0] == '*'))
+	if (match(aconf->passwd,sptr->passwd)) {
+	  if (!strchr(aconf->user, '.')) {
+	    sendto_realops("Warning! Invalid V-line with spoof host: %s", aconf->user);
+	    continue;
+	  }
+#ifdef SPOOF_NOTICE
+	  sendto_realops("%s spoofing: %s(%s) as %s", sptr->name,
+	    sptr->host, inetntoa((char*) &sptr->ip), aconf->user);
+#endif
+          strncpy_irc(sptr->host, aconf->user, HOSTLEN);
+	  SetOperSpoof(sptr);
+	  SetIPSpoof(sptr);
+          SetIPHidden(sptr);
+          return YES;
+      }
+    }
+  return NO;
+}
+#endif
diff -uNrd ircd-hybrid-6.0/src/s_debug.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/s_debug.c
--- ircd-hybrid-6.0/src/s_debug.c	Fri Nov 24 13:51:18 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/s_debug.c	Sat Nov 17 12:16:59 2001
@@ -64,7 +64,7 @@
 #ifdef  CMDLINE_CONFIG
   'C',
 #endif
-#ifdef        DO_ID
+#ifdef  DCCFILECHECK
   'd',
 #endif
 #ifdef  DEBUGMODE
@@ -76,7 +76,7 @@
 #ifdef  OPER_REHASH
   'E',
 #endif
-#ifdef GLINES
+#ifdef  GLINES
   'G',
 #endif
 #ifdef  HUB
@@ -88,12 +88,18 @@
 #ifndef NO_DEFAULT_INVISIBLE
   'I',
 #endif
+#ifdef  ALWAYS_TEMP_KLINES
+  'k',
+#endif
 #ifdef  OPER_KILL
   'K',
 #endif
 #ifdef  IDLE_FROM_MSG
   'M',
 #endif
+#ifdef  POWEROPERS
+  'O',
+#endif
 #ifdef  CRYPT_OPER_PASSWORD
   'p',
 #endif
@@ -103,11 +109,25 @@
 #ifdef  LOCOP_RESTART
   'r',
 #endif
+#ifdef  SERVICES
+#ifdef  ONLY_ID_JOIN_SUPPORT
+  'q',
+#endif
+#endif
 #ifdef  OPER_RESTART
   'R',
 #endif
+#ifdef  SERVICES
+  'S',
+#ifdef  SILENCE_SUPPORT
+  's',
+#endif
+#endif
 #ifdef  OPER_REMOTE
   't',
+#endif
+#ifdef  OPERSPOOF
+  'v',
 #endif
 #ifdef  VALLOC
   'V',
diff -uNrd ircd-hybrid-6.0/src/s_misc.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/s_misc.c
--- ircd-hybrid-6.0/src/s_misc.c	Tue Nov 21 01:49:32 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/s_misc.c	Wed Oct 24 08:14:36 2001
@@ -22,6 +22,8 @@
  *
  *  $Id: s_misc.c,v 1.69 2000/11/21 06:49:32 lusky Exp $
  */
+
+#include "m_commands.h"
 #include "s_misc.h"
 #include "client.h"
 #include "common.h"
@@ -55,6 +57,17 @@
   "Thursday", "Friday", "Saturday"
 };
 
+#ifdef SERVICES
+char* hidenicks[] = {
+         "CS" ,
+         "OS" , 
+         "STATISTIC" ,
+         "SEEN" ,
+         "SEENSERV"
+};
+#define ARR_SIZE 5
+#endif /* SERVICES */
+
 char* date(time_t clock) 
 {
   static        char        buf[80], plus;
@@ -202,4 +215,68 @@
              (float)((float)me.receiveK / (float)uptime));
 }
 
+#ifdef SERVICES
+long m_check_hide_chan( char * szName )
+{
+    int i = 0;
+    for( i=0;i<ARR_SIZE;i++)
+        if( !strcasecmp(szName, hidenicks[i]))
+            return 1;
+    return 0;
+}
+
+int m_serv_id(struct Client *cptr, struct Client *sptr, int parc, char *parv[])
+{
+    char *nick;
+    struct Client *acptr;
+    int ists = 1;
 
+    if (parc < 4) return 0;
+    if (parc < 5) ists--;
+    nick = parv[1];
+    acptr = find_client(nick,NULL);
+
+    if (!acptr)
+	return 0;
+    if (!IsServer(sptr))
+	return 0;
+
+    if (!strcasecmp(parv[3], "1")) {
+        if (!strcasecmp(parv[2], "NS")) {
+        	SetNSId(acptr);
+		CurrentIdentUsers++;
+		if (CurrentIdentUsers > MaxIdentUsers)
+		    MaxIdentUsers = CurrentIdentUsers;
+		if (ists)
+		    acptr->nick_ts = atoi(parv[4]);
+		else
+		    acptr->nick_ts = 0;
+        	sendto_serv_butone(cptr, "SERVID %s %s 1 %s", acptr->name,
+		    parv[2], ists ? parv[4] : "");
+        }
+        if (!strcasecmp(parv[2], "OS")) {
+        	SetOSId(acptr);
+        	sendto_serv_butone(cptr, "SERVID %s %s 1", acptr->name, parv[2]);
+        }
+        if (!strcasecmp(parv[2], "NK")) {
+		SetNKId(acptr);
+        	sendto_serv_butone(cptr, "SERVID %s %s 1", acptr->name, parv[2]);
+        }
+    } else
+      if (!strcasecmp(parv[3], "0")) {
+        if (!strcasecmp(parv[2], "NS")) {
+        	ClearNSId(acptr);
+		CurrentIdentUsers--;
+        	sendto_serv_butone(cptr, "SERVID %s %s 0", acptr->name, parv[2]);
+        }
+        if (!strcasecmp(parv[2], "OS")) {
+        	ClearOSId(acptr);
+        	sendto_serv_butone(cptr, "SERVID %s %s 0", acptr->name, parv[2]);
+        }
+        if (!strcasecmp(parv[2], "NK")) {
+		ClearNKId(acptr);
+		sendto_serv_butone(cptr, "SERVID %s %s 0", acptr->name, parv[2]);
+        }
+      }
+}
+#endif /* SERVICES */
diff -uNrd ircd-hybrid-6.0/src/s_serv.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/s_serv.c
--- ircd-hybrid-6.0/src/s_serv.c	Tue Nov 21 01:49:32 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/s_serv.c	Tue Apr 24 18:32:12 2001
@@ -60,6 +60,11 @@
 int MaxConnectionCount = 1;
 int MaxClientCount     = 1;
 
+#ifdef SERVICES
+int CurrentIdentUsers  = 0;
+int MaxIdentUsers  = 0;
+#endif
+
 /*
  * list of recognized server capabilities.  "TS" is not on the list
  * because all servers that we talk to already do TS, and the kludged
@@ -482,6 +487,14 @@
                  acptr->hopcount + 1, acptr->tsinfo, ubuf,
                  acptr->username, acptr->host,
                  acptr->user->server, acptr->info);
+#ifdef SERVICES
+      if (IsNSId(acptr))
+          sendto_one(cptr, "SERVID %s NS 1", acptr->name);
+      if (IsOSId(acptr))
+          sendto_one(cptr, "SERVID %s OS 1", acptr->name);
+      if (IsNKId(acptr))
+          sendto_one(cptr, "SERVID %s NK 1", acptr->name);
+#endif
     }
 }
 
@@ -681,7 +694,13 @@
              inpath,show_capabilities(cptr));
   log(L_NOTICE, "Link with %s established: (%s) link",
              inpath_ip,show_capabilities(cptr));
-
+#ifdef SERVICES
+  if (!strcasecmp(cptr->name, SERVICESHOST)) {
+      sendto_realops_flags(FLAGS_EXTERNAL,
+      "Services (%s) become up", cptr->name);
+      ServicesOn = 1;
+  }
+#endif
   add_to_client_hash_table(cptr->name, cptr);
   /* doesnt duplicate cptr->serv if allocated this struct already */
   make_server(cptr);
diff -uNrd ircd-hybrid-6.0/src/s_user.c ircd-hybrid-6rc7+unitedFreeBg-p1/src/s_user.c
--- ircd-hybrid-6.0/src/s_user.c	Sat Dec 30 19:12:02 2000
+++ ircd-hybrid-6rc7+unitedFreeBg-p1/src/s_user.c	Fri Nov 23 14:46:47 2001
@@ -84,6 +84,7 @@
   {FLAGS_FULL,  'f'},
   {FLAGS_INVISIBLE, 'i'},
   {FLAGS_SKILL, 'k'},
+  {FLAGS_POWEROPER, 'l'},
   {FLAGS_NCHANGE, 'n'},
   {FLAGS_OPER, 'o'},
   {FLAGS_LOCOP, 'O'},
@@ -93,6 +94,15 @@
   {FLAGS_EXTERNAL, 'x'},
   {FLAGS_SPY, 'y'},
   {FLAGS_OPERWALL, 'z'},
+#ifdef SERVICES
+  {FLAGS_SVCKILL, 'e'},
+ #ifdef SILENCE_SUPPORT
+  {FLAGS_SILENCE, 'S'},
+ #endif
+#endif
+#ifdef DCCFILECHECK
+  {FLAGS_NODCC, 'D'},
+#endif
   {0, 0}
 };
 
@@ -108,7 +118,11 @@
   0,            /* A */
   0,            /* B */
   0,            /* C */
+#ifdef DCCFILECHECK
+  FLAGS_NODCC,  /* D */
+#else
   0,            /* D */
+#endif
   0,            /* E */
   0,            /* F */
   0,            /* G */
@@ -123,7 +137,13 @@
   0,            /* P */
   0,            /* Q */
   0,            /* R */
+#ifdef SERVICES
+ #ifdef SILENCE_SUPPORT
+  FLAGS_SILENCE, /* S */
+ #endif
+#else
   0,            /* S */
+#endif
   0,            /* T */
   0,            /* U */
   0,            /* V */
@@ -137,14 +157,18 @@
   FLAGS_BOTS,   /* b */
   FLAGS_CCONN,  /* c */
   FLAGS_DEBUG,  /* d */
+#ifdef SERVICES
+  FLAGS_SVCKILL,/* e */
+#else
   0,            /* e */
+#endif
   FLAGS_FULL,   /* f */
   0,            /* g */
   0,            /* h */
   FLAGS_INVISIBLE, /* i */
   0,            /* j */
   FLAGS_SKILL,  /* k */
-  0,            /* l */
+  FLAGS_POWEROPER, /* l */
   0,            /* m */
   FLAGS_NCHANGE, /* n */
   FLAGS_OPER,   /* o */
@@ -386,6 +410,11 @@
   sendto_one(sptr, form_str(RPL_GLOBALUSERS), me.name, parv[0],
              Count.total, Count.max_tot);
 
+#ifdef SERVICES
+  sendto_one(sptr, form_str(RPL_IDENTUSERS), me.name, parv[0],
+             CurrentIdentUsers, MaxIdentUsers);
+#endif
+
   sendto_one(sptr, form_str(RPL_STATSCONN), me.name, parv[0],
              MaxConnectionCount, MaxClientCount,
              Count.totalrestartcount);
@@ -670,6 +699,10 @@
            sptr->username[USERLEN] = '\0';
         }
 
+#ifdef OPERSPOOF
+      find_v_line(sptr);
+#endif
+
       /* password check */
       if (!BadPtr(aconf->passwd) && 0 != strcmp(sptr->passwd, aconf->passwd))
         {
@@ -803,6 +836,11 @@
       sptr->flags |= FLAGS_KILLED;
       return exit_client(NULL, sptr, &me, "Ghost");
     }
+#ifdef NO_DEFAULT_DCCACCEPT
+  if( !strcasecmp( me.name, sptr->user->server ) ) 
+      sptr->umodes |= FLAGS_NODCC;
+#endif
+
   add_client_to_llist(&(sptr->servptr->serv->users), sptr);
 
 /* Increment our total user count here */
@@ -822,7 +860,20 @@
       sendto_one(sptr,
                  "NOTICE %s :*** Your host is %s, running version %s",
                  nick, get_listener_name(sptr->listener), version);
-      
+
+#ifdef SERVICES
+ #ifdef SILENCE_SUPPORT
+  #ifdef CLIENT_DEFAULT_SILENCE
+    if (!strcasecmp(me.name, sptr->user->server)) 
+      SetSilenceMode(sptr);
+  #endif
+ #endif
+      sptr->nick_ts = 0;
+      if (!ServicesOn)
+	sendto_one(sptr,
+	"NOTICE %s :*** Services are temporary down. Please be patient", nick);
+#endif
+
       sendto_one(sptr, form_str(RPL_CREATED),me.name,nick,creation);
       sendto_one(sptr, form_str(RPL_MYINFO), me.name, parv[0],
                  me.name, version);
@@ -1292,6 +1343,11 @@
   /*
   **  Finally set new nick name.
   */
+#ifdef SERVICES
+  if (IsNSId(sptr) && ServicesOn)
+	CurrentIdentUsers--;
+  ClearNSId(sptr);
+#endif
   if (sptr->name[0])
     del_from_client_hash_table(sptr->name, sptr);
   strcpy(sptr->name, nick);
@@ -1342,6 +1398,7 @@
    * parc == 9 on a normal TS style server-to-server NICK
    *      introduction
    */
+
   if ((IsServer(sptr)) && (parc < 9))
     {
       /*
@@ -1424,7 +1481,7 @@
       return 0;
     }
 
-  if(MyConnect(sptr) && !IsServer(sptr) && !IsAnOper(sptr) &&
+  if(MyConnect(sptr) && !IsServer(sptr) && !IsOper(sptr) &&
      find_q_line(nick, sptr->username, sptr->host)) 
     {
       sendto_realops_flags(FLAGS_REJ,
@@ -2054,9 +2111,11 @@
             {
               if (what == MODE_ADD)
                 sptr->umodes |= flag;
-              else
+              else {
                 sptr->umodes &= ~flag;  
-            }
+              } /* else - mode del */  
+            } /* if flag... */
+
           else
             {
               if ( MyConnect(sptr))
@@ -2067,6 +2126,43 @@
 
   if(badflag)
     sendto_one(sptr, form_str(ERR_UMODEUNKNOWNFLAG), me.name, parv[0]);
+
+#ifdef DCCFILECHECK
+  if ((setflags & FLAGS_NODCC) && !IsNoDccFiles(sptr))
+    {
+	sendto_one(sptr,":%s NOTICE %s :You have removed your server protection flag. You can return it by typing /mode %s +D",
+        me.name,parv[0], parv[0]);
+	sptr->umodes &= ~FLAGS_NODCC;
+    }
+#endif
+
+#ifdef SERVICES
+ #ifdef SILENCE_SUPPORT
+  if (MyConnect(sptr) && !(setflags & FLAGS_SILENCE) && (HasSilenceMode(sptr)))
+    {
+	sendto_one(sptr,":%s NOTICE %s :You have put Silence mode on your nickname (+S). You will NOT receive any private messages, ctcps, notices from unregistered (too recently registered) nicknames",
+    	    me.name,parv[0], parv[0]);
+    }
+ #endif
+#endif
+
+#ifdef POWEROPERS
+  if ((sptr->umodes & FLAGS_POWEROPER) && !IsSetOperN(sptr))
+    {
+      sendto_one(sptr,":%s NOTICE %s :*** You need oper and N flag for +l",
+                 me.name,parv[0]);
+      sptr->umodes &= ~FLAGS_POWEROPER;
+    }
+#else
+  if (sptr->umodes & FLAGS_POWEROPER)
+    {
+      sendto_one(sptr,":%s NOTICE %s :*** Your admin did not compile IRCD with extra IrcOp features",
+                 me.name,parv[0]);
+      sendto_one(sptr,":%s NOTICE %s :*** He/She can do this with #define POWEROPERS in include/config.h file",
+                 me.name,parv[0]);
+      sptr->umodes &= ~FLAGS_POWEROPER;
+    }
+#endif
 
   if ((sptr->umodes & FLAGS_NCHANGE) && !IsSetOperN(sptr))
     {
